import { CodeTokenBuilder, CodeTokenProps, CodeTokenType } from "../types";

export const createToken = new Proxy(
  {},
  {
    get: (_, prop: CodeTokenType) => {
      const builder: CodeTokenBuilder = (props) => ({
        type: prop,
        ...props,
      });
      return builder;
    },
  }
);

export const whiteSpace = (count: number = 1): CodeTokenProps => ({
  type: "default",
  children: " ".repeat(count),
});
